% reset GOAT paths and rehash
% syntax:
% >> GOAT_rehash
% addpath(genpath(...GOAT/Code))     ;
% addpath(genpath(...GOAT/Scripts))     ;
% addpath(genpath(...GOAT/MyScripts))     ;

GOATPath = fileparts(fileparts(which('GOAT.m'))) ;
addpath(genpath(fullfile(GOATPath,'Code')))        ;
addpath(genpath(fullfile(GOATPath,'Scripts')))     ;
addpath(genpath(fullfile(GOATPath,'MyScripts')))   ;
savepath ;
clear GOATPath ;
rehash ;

try
    [DummyFolders,ModificationFiles] = GOAT_FileFolderTrees(fullfile(fileparts(fileparts(which('GOAT.m'))),'MyScripts','MyCode')) ;
    if size(ModificationFiles,1) % if there are code modifications (located at 'GOAT/MyScripts/MyCode')
        [DummyFolders,UtilFiles] = GOAT_FileFolderTrees(fullfile(fileparts(which('GOAT.m')),'Utils')) ;
        [DummyFolders,PackagesFiles] = GOAT_FileFolderTrees(fullfile(fileparts(which('GOAT.m')),'Packages')) ;
        Modifications = ismember(ModificationFiles(:,2),[UtilFiles(:,2) ; PackagesFiles(:,2)]) ;
        if sum(Modifications)
            disp 'The following ''MyScripts/MyCode'' files override original source files:'
            for i = 1:length(Modifications)
                if Modifications(i)
                    disp(ModificationFiles{i,2}) ;
                end
            end
        end
    end
end