% AveragingType is used in GOAT calculations of hovmoller plot
% NF is the length of the periodic or continuous time series that is displayed in the plot
%
%

function NPeriod = AveragingType(G,NF)
[year1,month1,day1,hour1] = GOAT_serial2date(G.Addresses.Default,G.Limits.S1) ;
[year2,month2,day2,hour2] = GOAT_serial2date(G.Addresses.Default,G.Limits.S2) ;
if G.Limits.Default.Sequential ||  ...
        month1*10000 + day1*100 + hour1 == ...
        month2*10000 + day2*100 + hour2 || ...
        G.Limits.Default.Sequential == 0 && G.Limits.Default.ClimatologyContinuous == 1
    NPeriod = NF ;
else
    Year0 = GOAT_serial2date(G.Addresses.Default,1) ;
    if month2*10000 + day2*100 + hour2 >= month1*10000 + day1*100 + hour2
        S1 = GOAT_getSerial(year1,month1,day1,hour1,G.TimeFieldVirtual,Year0) ;
        S2 = GOAT_getSerial(year1,month2,day2,hour2,G.TimeFieldVirtual,Year0) ;
        if GOAT_leapyear(year1,G.TimeFieldVirtual) && month2*100 + day2 > 228  && month1*100 + day1 < 228
            S2 = S2 - 1 ;
        end
    else
        S1 = GOAT_getSerial(year1,month1,day1,hour1,G.TimeFieldVirtual,Year0) ;
        S2 = GOAT_getSerial(year1+1,month2,day2,hour2,G.TimeFieldVirtual,Year0) ;
        if GOAT_leapyear(year1,G.TimeFieldVirtual) && month1*100 + day1 <= 228  || month2*100 + day2 > 228
            S2 = S2 - 1 ;
        end
    end
    NPeriod = S2 - S1 + 1 ;
end