% GOAT_ALP_20CR_LINK link code for 20 Century Reanalysis

G = GOAT_Environment ;
link_dir = fullfile(fileparts(which('GOAT.m')),'Utils','DataManagementCode','ALP','20CR') ; % MERRA ALP code folder
Data_ALP = fullfile(fileparts(fileparts(which('GOAT.m'))),'Data_LINK') ; % LINK Data folder

Years = 1871:2012 ;

file_root = {'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/pressure/'                 ,'DailyX4','Isobaric','4 Times Daily Pressure level variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/pressure_sprd/'                     ,'DailyX4','Isobaric_sprd','Pressure level Ensemble 4 Times Daily Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/pressure/'                  ,'Daily'  ,'Isobaric','Daily averages Pressure level' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/pressure_sprd/'             ,'Daily'  ,'Isobaric_sprd','Pressure level Daily averages of Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/monolevel/'                         ,'DailyX4','Monolevel','4 Times Daily Monolevel variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/monolevel_sprd/'                    ,'DailyX4','Monolevel_Sprd','Monolevel Ensemble 4 Times Daily Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/monolevel/'                 ,'Daily'  ,'Monolevel','Daily averages Monolevel' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/monolevel_sprd/'            ,'Daily'  ,'Monolevel_Sprd','Monolevel Daily averages of Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/gaussian/monolevel/'                ,'DailyX8','Monolevel_Gaussian','8 Times Daily Gaussian Gridded Data (192 x 94)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/gaussian_sprd/monolevel/'           ,'DailyX8','Monolevel_Gaussian_Sprd','8 Times Daily Gaussian Gridded Data (192 x 94) Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/gaussian/monolevel/'        ,'Daily'  ,'Monolevel_Gaussian','Gaussian Gridded Data (192 x 94) Daily averages' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/gaussian_sprd/monolevel/'   ,'Daily'  ,'Monolevel_Gaussian_Sprd','Gaussian Gridded Data (192 x 94) Daily averages of Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/time_invariant/'                    ,'List'   ,'Monolevel','Monolevel time invariants' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/gaussian/time_invariant/'           ,'List'   ,'Monolevel_Gaussian','Monolevel Gaussian time invariants' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/gaussian/subsurface/'               ,'DailyX8','Subsurface','Subsurface variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/gaussian_sprd/subsurface/'          ,'DailyX8','Subsurface_Sprd','Subsurface variables Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/gaussian/subsurface/'       ,'Daily'  ,'Subsurface','Daily averages of Subsurface variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Dailies/gaussian_sprd/subsurface/'  ,'Daily'  ,'Subsurface_Sprd','Daily averages of Subsurface variables Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/pressure/'                ,'Monthly','Isobaric','Monthly Pressure level and Monolevel variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/pressure_sprd/'           ,'Monthly','Isobaric_sprd','Monthly Pressure level and Monolevel Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/monolevel/'               ,'Monthly','Monolevel','Monthly Pressure level and Monolevel variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/monolevel_sprd/'          ,'Monthly','Monolevel_Sprd','Monthly Pressure level and Monolevel Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/gaussian/monolevel/'      ,'Monthly','Monolevel_Gaussian','Monthly Gaussian Gridded Data (192 x 94)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/gaussian_sprd/monolevel/' ,'Monthly','Monolevel_Gaussian_Sprd','Monthly Gaussian Gridded Data (192 x 94) Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/gaussian/subsurface/'     ,'Monthly','Subsurface','Monthly mean Subsurface variables' ; ...
    'http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/Monthlies/gaussian_sprd/subsurface/','Monthly','Subsurface_Sprd','Monthly mean Subsurface variables Ensemble Spread (standard deviation of the ensemble deviations at each time - not RMS)' ; ...
    } ;


Pressure_filenames = {'air','hgt','omega','rhum','shum','uwnd','vwnd'} ;
Monolevel_filenames = {'air.sig995','air.tropo','cape','cin','cldwtr.eatm','hgt.tropo','omega.sig995','pottmp.sig995','pr_wtr.eatm','pres.sfc','pres.tropo','prmsl','rhum.sig995','tco3.eatm' , ...
    'uwnd.sig995','uwnd.tropo','vwnd.sig995','vwnd.tropo'} ;
Monolevel_Gauss_filenames = {'air.2m','air.sfc','albedo','cprat','cwork.eatm','dlwrf.sfc','dswrf.sfc','gflux','hpbl','icec','icet','lhtfl','pevpr','pr_wtr.eatm','prate','press.sfc','runoff','shtfl', ...
    'shum.2m','snod','snowc','soilm','ssrunoff','tcdc.bndrylyr','tcdc.convcld','tcdc.eatm','tcdc.lowcld','tcdc.midcld','tcdc.topcld','tmax.2m','tmin.2m','trans','uflx','ugwd','ulwrf.ntat','ulwrf.sfc','uswrf.ntat', ...
    'uswrf.sfc','uwnd.10m','vflx','vgwd','vwnd.10m','weasd'} ;
Invariant_filenames = {'hgt.sfc'} ;
Invariant_Gauss_filenames = {'hgt.sfc','soiltype','vegtype','land'} ;
Subsurface_filenames = {'soill','soilw','tsoil'} ;

% Units and Name Conversion Array
CV = cell(1,4) ; qV = 1 ;
[CV(qV,:)] = deal([{'name'}    ,{'standard_name'},{'Factor'},{'Units'}]) ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'hgt'}     ,{'zg'}           ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'hgt.sfc'} ,{'zgs'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'air'}     ,{'ta'}           ,{1}       ,{'K'}])     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'omega'}   ,{'wap'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'rhum'}    ,{'hur'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'shum'}    ,{'hus'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'uwnd'}    ,{'ua'}           ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'vwnd'}    ,{'va'}           ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'air.sfc'} ,{'tas'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'prate'}   ,{'pr'}           ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'pres.sfc'},{'ps'}           ,{1}       ,{[]}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'press.sfc'},{'ps'}          ,{1}       ,{[]}])      ; qV = qV + 1 ;


CompressFlag = 0 ;
totaltoc = 0 ;
Ext = 'dap' ;
longitude_dimname = 'lon' ;
latitude_dimname  = 'lat' ;
level_dimname     = 'level' ;
time_dimname      = 'time';
today = date ;
First_Year = 1871 ;
First_Month = 1 ;
First_Day = 1 ;
First_Hour = 0 ;
Last_Year = 2012 ;
Last_Month = 12 ;
Last_Day = 31 ;
Last_Hour = 18 ;

for s = 15:18 %1:size(file_root,1)
    tic
    Data_LINK = fullfile(Data_ALP,'20CR_LINK',file_root{s,3},file_root{s,2}) ;
        infostr = sprintf([file_root{s,4}, ...
        '\nAbout 20th Century Reanalysis (V2) (source: UCAR Climate Data Guide)', ...
        '\nThe Twentieth Century Reanalysis (20CR) provides a comprehensive global atmospheric circulation data set spanning 1870-2010.', ...
        '\nIts chief motivation is to provide an observational validation data set, with quantified uncertainties,', ...
        '\nfor assessing climate model simulations of the 20th century, with emphasis on the statistics of daily weather.', ...
        '\nThe analyses are generated by assimilating only surface pressures and using monthly SST and sea ice distributions as boundary conditions', ...
        '\nwithin a ''deterministic'' Ensemble Kalman Filter (EKF).'  , ...
        '\nA unique feature of the 20CR is that estimates of uncertainty are derived using a 56 member ensemble.' , ...
        '\nOverall, the quality is approximately that of current three-day NWP forecasts.'
        ]) ;
    
    mkdir(Data_LINK) ;
    save(fullfile(Data_LINK,'info.mat'),'infostr')
    opendap_address = file_root{s,1} ;
    switch s
        case {1,2,3,4,19,20}
        varlist = Pressure_filenames ;
        case {5,6,7,8,21,22}
        varlist = Monolevel_filenames ;
        case {9,10,11,12,23,24}    
        varlist = Monolevel_Gauss_filenames ;
        case 13
        varlist = Invariant_filenames ;
        case 14
        varlist = Invariant_Gauss_filenames ;
        case {15,16,17,18,25,26}
        varlist = Subsurface_filenames ;    
    end
    
    
    if ismember(file_root{s,3},{'Subsurface','Subsurface_Sprd'})
        VerticalOrdinate = 'Depth (m)' ;
    else
        VerticalOrdinate = 'Pressure (mb)' ;
    end
    
    
    disp(['Building link table ',file_root{s,3},' . . .'])
    year1 = First_Year ; month1 = First_Month ; day1 = First_Day ; hour1 = First_Hour ;
    year2 = Last_Year  ; month2 = Last_Month  ; day2 = Last_Day  ;
    switch file_root{s,2}
        case {'Monthly','Daily'}
            hour2 = 00 ;
        case 'DailyX4'
            hour2 = 18 ;
        case 'DailyX8'
            hour2 = 21 ;
    end
    
    CB    = cell(1,20) ;
    [CB(1,:)] = deal([{'Calendar'},{'link type'},{'file path'},{'varname'},{'x dim #'},{'y dim #'},{'z dim #'},{'t dim #'},{'year1'},{'month1'},{'day1'},{'hour1'},{'year2'},{'month2'},{'day2'},{'hour2'},{'Description'},{'Units'},{''},{''}]) ;
    q = 1 ;
    GOAT_Display_message(G,'','init')
    for d = 1:length(varlist)
        GOAT_Display_message(G,['Surveying variables . . . ',num2str(d/length(varlist)*100,'%02.0f')],'stat')
        if strcmpi(file_root(s,2),'List')
            try
                a = ncinfo([opendap_address,varlist{d},'.nc'],varlist{d}) ;
                varfilename = varlist{d} ;
            catch
                [FileNamePath,FileName,FileExt] = fileparts(varlist{d}) ;
                a = ncinfo([opendap_address,varlist{d},'.nc'],FileName) ;
                varfilename = FileName ;
            end
        elseif strcmpi(file_root{s,2},'Monthly')
            try
                a = ncinfo([opendap_address,varlist{d},'.mon.mean.nc'],varlist{d}) ;
                varfilename = varlist{d} ;
            catch
                try
                [FileNamePath,FileName,FileExt] = fileparts(varlist{d}) ;
                a = ncinfo([opendap_address,varlist{d},'.mon.mean.nc'],FileName) ;
                varfilename = FileName ;
                catch
                disp(['could not obtain attributes for: ',opendap_address,varlist{d},'.mon.mean.nc'])
                GOAT_Display_message(G,'','init')
                continue ; 
                end
            end
        else
            try
                a = ncinfo([opendap_address,varlist{d},'.',int2str(First_Year),'.nc'],varlist{d}) ;
                varfilename = varlist{d} ;
            catch
                try
                    [FileNamePath,FileName,FileExt] = fileparts(varlist{d}) ;
                    a = ncinfo([opendap_address,varlist{d},'.',int2str(First_Year),'.nc'],FileName) ;
                    varfilename = FileName ;
                catch
                    disp(['could not obtain attributes for: ',opendap_address,varlist{d},'.',int2str(First_Year),'.nc'])
                    GOAT_Display_message(G,'','init')
                    continue
                end
            end
        end
        q = q + 1 ;
        CB(q,1) = file_root(s,2)  ; % Temporal Resolution
        CB(q,2) = {1}                   ; % type
        CB(q,3) = {opendap_address}     ; % opendap url
        CB(q,4) = {varfilename}            ; % variable name (short)
        CB(q,5:8) = {0}                 ; % default dimension number
        for j = 1:length(a.Dimensions)
            if strcmpi(a.Dimensions(j).Name,longitude_dimname) ; CB(q,5) = {j} ; end
            if strcmpi(a.Dimensions(j).Name,latitude_dimname)  ; CB(q,6) = {j} ; end
            if strcmpi(a.Dimensions(j).Name,level_dimname)     ; CB(q,7) = {j} ; end
            if strcmpi(a.Dimensions(j).Name,time_dimname)      ; CB(q,8) = {j} ; end
        end
        [CB(q,9:16)] = deal([{year1},{month1},{day1},{hour1},{year2},{month2},{day2},{hour2}]) ;
        long_name = a.Attributes(find(strcmp({a.Attributes.Name},'long_name'))).Value ;
        CB(q,17) = {long_name} ;
        Units = a.Attributes(find(strcmp({a.Attributes.Name},'units'))).Value ;
        CV_Idx = find(strcmp(varlist{d},CV(:,1))) ;
        if ~isempty(CV_Idx)
            if ~isempty(CV{CV_Idx,4})
                Units = CV{CV_Idx,4} ;
            end
        end
        CB(q,18) = {Units} ;
        CB(q,19) = varlist(d) ;
    end
    
    % Identify Fields
    Fields = unique(CB(2:end,19)) ;
    for f = 1:length(Fields)
        Defs = [] ;
        CF = CB(strcmp(Fields(f),CB(:,19)),:) ;
        % Find standard field name
        Idx = find(strcmpi(Fields(f),CV(:,1))) ;
        if isempty(Idx)
            FieldName = lower(Fields{f}) ;
        else
            FieldName = lower(CV{Idx,2}) ;
        end
        disp(['linking field ',file_root{s,3},'/',file_root{s,2},'  ',int2str(f),'/',int2str(length(Fields)),' :  ',regexprep(FieldName,'[.]','_'),' . . . '])
        mkdir(fullfile(Data_LINK,regexprep(FieldName,'[.]','_'))) ;
        %VerticalOrdinate =
        Units            = CF{1,18} ;
        FieldDescription = CF{1,17} ;
        % retrieve spatial vectors
        if strcmp(file_root{s,2},'List')
            YearStr = '' ;
        elseif strcmpi(file_root{s,2},'Monthly')
            YearStr = '.mon.mean' ; 
        else
            YearStr = ['.',int2str(First_Year)] ;
        end
        
        lon = double(ncread([opendap_address,Fields{f},YearStr,'.nc'],longitude_dimname)) ;
        lat = double(ncread([opendap_address,Fields{f},YearStr,'.nc'],latitude_dimname)) ;
        av = ncinfo([opendap_address,Fields{f},YearStr,'.nc'],CF{1,4}) ;
        
        if strcmp(VerticalOrdinate,'Pressure (mb)')
            if cell2mat(CF(1,7)) == 0
                P = 1000 ;
            else
                P = double(ncread([opendap_address,Fields{f},YearStr,'.nc'],level_dimname)) ;
            end
        else
            if cell2mat(CF(1,7)) == 0
                P = 0 ;
            else
                P = double(ncread([opendap_address,Fields{f},YearStr,'.nc'],level_dimname))/100 ;
            end
        end
        lev = P ; 
        save(fullfile(Data_LINK,regexprep(FieldName,'[.]','_'),'Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
        % move on to creating Attributes
        dates1 = cell2mat(CF(:,9 ))*1.e10 + cell2mat(CF(:,10)).*1.e4 + cell2mat(CF(:,11)).*1.e2 + cell2mat(CF(:,12))  ;
        dates2 = cell2mat(CF(:,13))*1.e10 + cell2mat(CF(:,14)).*1.e4 + cell2mat(CF(:,15)).*1.e2 + cell2mat(CF(:,16))  ;
        [S, Si] = sort(dates1) ;
        year1 = min(cell2mat(CF(:,9 ))) ;
        year2 = max(cell2mat(CF(:,13))) ;
        if strcmp(file_root{s,2},'List')
            G.Addresses.Default      = cell(2,1)                   ;
            G.Addresses.Default(1,1) = {fullfile('Invariant','data.mat')} ;
            G.Addresses.Default(2,1) = {'List'}          ;
        else
            G = GOAT_Produce_DefaultAddress(G,year1,year2,file_root{s,2},Ext) ;
        end
        Addresses = G.Addresses.Default ;
        
        Attributes = cell(length(Addresses),8) ;
        % Attributes(i,1) = filename ;
        % Attributes(i,2) = varname  ;
        % Attributes(i,3) = start    ;
        % Attributes(i,4) = count    ;
        % Attributes(i,5) = factor   ;
        % Attributes(i,6) = permute   ;
        % Attributes(i,7) = reshape (add dimensions)   ;
        % Attributes(i,8) = valid range   ;
        % Assign Attributes to each date
        for k = 1:length(Addresses) - 1 ;
            if strcmp(file_root{s,2},'List')
                Idf = 1 ;
                S   = 1 ;
                Sf  = 1 ;
                YearStr = '' ;
            else
                [year,month,day,hour] = GOAT_serial2date(Addresses,k) ;
                Idf = 1 ;
                if strcmpi(file_root{s,2},'Monthly')
                    S  = GOAT_getSerial(year,month,day,hour,file_root{s,2},year1)  ;
                    Sf = GOAT_getSerial(year,CF{Idf,10},CF{Idf,11},CF{Idf,12},file_root{s,2},year1)  ;
                else
                    S  = GOAT_getSerial(year,month,day,hour,file_root{s,2},year)  ;
                    Sf = GOAT_getSerial(year,CF{Idf,10},CF{Idf,11},CF{Idf,12},file_root{s,2},year)  ;
                end
                YearStr = ['.',int2str(year)] ;
            end
            if strcmpi(file_root{s,2},'Monthly')
                Attributes(k,1) = {[opendap_address,Fields{f},'.mon.mean.nc']} ;
            else
                Attributes(k,1) = {[opendap_address,Fields{f},YearStr,'.nc']} ;
            end
            Attributes(k,2) = CF(1,4) ;
            Attributes(k,5) = {1}  ;
            
            % locate dimensions
            dims = cell2mat(CF(1,5:8)) ;
            dims = dims(dims>0) ;
            
            if ~(isequal(dims,[1 2]) || isequal(dims,[1 2 3]) || isequal(dims,[1 2 3 4]))
                %                         Attributes(k,6) = {0}   ;
                %                     else
                Attributes(k,6) = {dims}   ;
            end
            
            switch length(dims)
                case 2 % lat,lon
                    start = [1 1] ;
                    count = [inf inf] ;
                case 3 % lat,lon,time
                    start = [1 1 1] ;
                    start(dims(3)) = (S-Sf)+1 ;
                    count = [1 1 1] ;
                    count(dims(1)) = inf ;
                    count(dims(2)) = inf ;
                case 4 % lat lon level time
                    start = [1 1 1 1] ;
                    start(dims(4)) = (S-Sf)+1 ;
                    count = [1 1 1 1] ;
                    count(dims(1)) = inf ;
                    count(dims(2)) = inf ;
                    count(dims(3)) = inf ;
            end
            
            Attributes(k,3) = {start} ;
            Attributes(k,4) = {count} ;
            if ismember(FieldName,{'soill','soilw','tsoil'})
            Attributes(k,8) = {[-1.e10 1.e10]} ;
            end
        end
        
        Attributes(end,1) = {Ext} ; % 'mat' | 'ncf' | 'dap' | 'gb1' | 'gb2'
        Attributes(end,2) = {[First_Year Last_Year]} ;
        Attributes(end,3) = {Defs} ; % Defs Struct
        Attributes(end,4) = file_root(s,2) ;
        Attributes = GOAT_ALP_CompressAttributes(Attributes) ;
        if strcmp(file_root{s,2},'List')
            mkdir(fullfile(Data_LINK,regexprep(FieldName,'[.]','_'),'Invariant')) ;
            save(fullfile(Data_LINK,regexprep(FieldName,'[.]','_'),'Invariant','link_field.mat'),'Attributes') ;
        else
            save(fullfile(Data_LINK,regexprep(FieldName,'[.]','_'),'link_field.mat'),'Attributes') ;
        end
        if strcmp(FieldName,'ps')
            if ~exist(fullfile(Data_LINK,'BoerBeta'),'dir') ;
                mkdir(fullfile(Data_LINK,'BoerBeta')) ;
            end
            Attributes(end,1) = {'bds'} ;
            save(fullfile(Data_LINK,'BoerBeta','link_field.mat'),'Attributes') ;
            FieldDescription = 'Boer Beta Function' ;
            Units = '1' ;
            try
                lev = double(ncread(opendap_address,level_dimname)) ;
                save(fullfile(Data_LINK,'BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
            catch
                % 2D dataset Boer Beta is a place holder for other 3D datasets
            end
        end
    end
    TT = toc ;
    totaltoc = totaltoc + TT ;
    HH = floor(TT/3600) ;
    MM = floor((TT - HH*3600)/60) ;
    SS = TT - HH*3600 - MM*60 ;
    if HH > 0
        TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
    elseif MM > 0
        TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
    elseif SS > 0
        TimeString = [int2str(SS),' seconds.'] ;
    end
    disp(['Linking 20CR ',int2str(s),' of ',int2str(size(file_root,1)),' -- ',file_root{s,3},'/',file_root{s,2},' completed in ',TimeString]) ;
end % s

disp('placing BoerBeta files . . . ')
% Set BoerBeta Dims files:
% First set P from a reference 3D field ('ta')
load(fullfile(Data_ALP,'20CR_LINK','Isobaric','Daily','ta','Dims.mat')) ;  P0 = lev ; 
load(fullfile(Data_ALP,'20CR_LINK','Monolevel','Daily','ps','Dims.mat')) ;  lev = P0 ;
FieldDescription = 'BoerBeta Function' ; 
Units = '1' ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric'    ,'Daily'  ,'BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'Daily'  ,'BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric'    ,'DailyX4','BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'DailyX4','BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric'    ,'Monthly','BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'Monthly','BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Daily' ,'BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Daily'  ,'BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','DailyX4','BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','DailyX4','BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
mkdir(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Monthly','BoerBeta')) ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Monthly','BoerBeta','Dims.mat'),'lev','lon','lat','Units','VerticalOrdinate','FieldDescription') ; 
% Copy over the link_field.mat file from ps of Isobaric (not spread)
load(fullfile(Data_ALP,'20CR_LINK','Monolevel'    ,'Daily'  ,'ps'      ,'link_field.mat')) ;  
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'Daily'  ,'BoerBeta','link_field.mat'),'Attributes') ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Daily'  ,'BoerBeta','link_field.mat'),'Attributes') ; 
load(fullfile(Data_ALP,'20CR_LINK','Monolevel'    ,'DailyX4','ps'      ,'link_field.mat')) ;  
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'DailyX4','BoerBeta','link_field.mat'),'Attributes') ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','DailyX4','BoerBeta','link_field.mat'),'Attributes') ; 
load(fullfile(Data_ALP,'20CR_LINK','Monolevel'    ,'Monthly','ps'      ,'link_field.mat')) ;  
save(fullfile(Data_ALP,'20CR_LINK','Isobaric'     ,'Monthly','BoerBeta','link_field.mat'),'Attributes') ; 
save(fullfile(Data_ALP,'20CR_LINK','Isobaric_Sprd','Monthly','BoerBeta','link_field.mat'),'Attributes') ; 

TT = totaltoc ;
HH = floor(TT/3600) ;
MM = floor((TT - HH*3600)/60) ;
SS = TT - HH*3600 - MM*60 ;
if HH > 0
    TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif MM > 0
    TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif SS > 0
    TimeString = [int2str(SS),' seconds.'] ;
end
disp(['Linking entire 20CR OPeNDAP dataset completed in ',TimeString]) ;

