% Indices Code
G = GOAT_Environment ; 

%% Save
save('Indices.mat','Indices')
%% NAO Daily
G.Addresses.Default   = G.Addresses.DailyAddressX8(1:8:end) ;
Indices.NAO.Source    = 'http://www.cpc.ncep.noaa.gov/products/precip/CWlink/pna/nao.shtml' ;
Indices.NAO.FullName  = 'North Atlantic Oscillation' ;
Indices.NAO.BeginDate = 'Jan.01.1950' ;
Indices.NAO.EndDate   = 'Sep.30.2013' ;
Indices.NAO.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:length(VarName4)
    year  = VarName1(i) ; 
    month = VarName2(i) ; 
    day   = VarName3(i) ;
    Indices.NAO.index(GOAT_getSerial(year,month,day,0,'Daily',1950)) = VarName4(i) ; 
end
    
%% AAO Daily
G.Addresses.Default   = G.Addresses.DailyAddressX8(1:8:end) ;
Indices.AAO.Source    = 'http://www.cpc.ncep.noaa.gov/products/precip/CWlink/daily_ao_index/aao/aao.shtml' ;
Indices.AAO.FullName  = 'Antarctic Oscillation' ;
Indices.AAO.BeginDate = 'Jan.01.1979' ;
Indices.AAO.EndDate   = 'Sep.30.2013' ;
Indices.AAO.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:length(VarName5)
    year  = VarName5(i) ; 
    month = VarName6(i) ; 
    day   = VarName7(i) ;
    Indices.AAO.index(GOAT_getSerial(year,month,day,0,'Daily',1979)) = VarName8(i) ; 
end

%% AO Daily
G.Addresses.Default   = G.Addresses.DailyAddressX8(1:8:end) ;
Indices.AO.Source    = 'http://www.cpc.ncep.noaa.gov/products/precip/CWlink/daily_ao_index/ao.shtml' ;
Indices.AO.FullName  = 'Arctic Oscillation' ;
Indices.AO.BeginDate = 'Jan.01.1950' ;
Indices.AO.EndDate   = 'Sep.30.2013' ;
Indices.AO.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:length(VarName9)
    year  = VarName9(i) ; 
    month = VarName10(i) ; 
    day   = VarName11(i) ;
    Indices.AO.index(GOAT_getSerial(year,month,day,0,'Daily',1950)) = VarName12(i) ; 
end


%% PNA Pacific NorthAmerican Pattern Daily
G.Addresses.Default   = G.Addresses.DailyAddressX8(1:8:end) ;
Indices.PNA.Source    = 'http://www.cpc.ncep.noaa.gov/products/precip/CWlink/daily_ao_index/ao.shtml' ;
Indices.PNA.FullName  = 'Arctic Oscillation' ;
Indices.PNA.BeginDate = 'Jan.01.1950' ;
Indices.PNA.EndDate   = 'Sep.30.2013' ;
Indices.PNA.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:length(VarName13)
    year  = VarName13(i) ; 
    month = VarName14(i) ; 
    day   = VarName15(i) ;
    Indices.PNA.index(GOAT_getSerial(year,month,day,0,'Daily',1950)) = VarName16(i) ; 
end

%% MEI extended
G.Addresses.Default   = G.Addresses.MonthlyAddress ;

Indices.MEIx.Source    = 'http://www.esrl.noaa.gov/psd/enso/mei.ext/index.html#data' ;
Indices.MEIx.FullName  = 'Extended Multivariate ENSO Index' ;
Indices.MEIx.BeginDate = 'Jan.1871' ;
Indices.MEIx.EndDate   = 'Dec.2005' ;
Indices.MEIx.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:size(mei,1)
    year = mei(i,1) ;
    for j = 1:12
    month = j ; 
    Indices.MEIx.index(GOAT_getSerial(year,month,1,0,'Monthly',1871)) = mei(i,j+1) ; 
    end
    
end

%% MEI 
G.Addresses.Default   = G.Addresses.MonthlyAddress ;

Indices.MEI.Source    = 'http://www.esrl.noaa.gov/psd/enso/mei.ext/index.html#data' ;
Indices.MEI.FullName  = 'Extended Multivariate ENSO Index' ;
Indices.MEI.BeginDate = 'Jan.1950' ;
Indices.MEI.EndDate   = 'Sep.2013' ;
Indices.MEI.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:size(mei,1)
    year = mei(i,1) ;
    for j = 1:12
    month = j ; 
    Indices.MEI.index(GOAT_getSerial(year,month,1,0,'Monthly',1950)) = mei(i,j+1) ; 
    end
    
end

%% ENSO 3.4 ERSST
% first put text data into a cell named enso ;

G.Addresses.Default   = G.Addresses.MonthlyAddress ;
Indices.ENSO34.Source    = 'http://www.esrl.noaa.gov/psd/data/correlation/nina34.data' ;
Indices.ENSO34.FullName  = 'ENSO 3.4 region Index' ;
Indices.ENSO34.BeginDate = 'Jan.1950' ;
Indices.ENSO34.EndDate   = 'Sep.2013' ;
Indices.ENSO34.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:length(enso)
    Yeardata = str2num(cell2mat(enso(i,1))) ; 
    year = Yeardata(1) ; 
    for j = 1:12
    month = j ; 
    Indices.ENSO34.index(GOAT_getSerial(year,month,1,0,'Monthly',1950)) = Yeardata(j+1) ; 
    end
end
Indices.ENSO34.index(Indices.ENSO34.index<-90) = nan ; 


%% ONI Oceanic NINO Index
% first put excel data into oni ;
% /Users/oradam/Documents/MATLAB/GOAT/Archive/Nino34/ENSO3_4.xlx
G.Addresses.Default   = G.Addresses.MonthlyAddress ;
Indices.ONI.Source    = 'http://www.cpc.ncep.noaa.gov/products/analysis_monitoring/ensostuff/ensoyears.shtml' ;
Indices.ONI.FullName  = 'Oceanic NINO Index' ;
Indices.ONI.BeginDate = 'Jan.1950' ;
Indices.ONI.EndDate   = 'Aug.2013' ;
Indices.ONI.index     = zeros(length(G.Addresses.Default),1)*nan ; 

for i = 1:size(oni,1)
    year = oni(i,1) ;
    for j = 1:12
    month = j ; 
    Indices.ONI.index(GOAT_getSerial(year,month,1,0,'Monthly',1950)) = oni(i,j+1) ; 
    end
    
end
Indices.ONI.index(Indices.ONI.index<-90) = nan ; 


%% PDO Oceanic Index
% Copy and paste text data to XL document from
% http://jisao.washington.edu/pdo/PDO.latest
% remove asterixes
% Save as:
% /Users/oradam/Documents/MATLAB/GOAT/Archive/Indices/PDO.xlsx
GOAT_Address = '/Users/oradam/Documents/MATLAB/GOAT/Data/Indices/Monthly/PDO' ; 
[num,txt,raw] = xlsread('/Users/oradam/Documents/MATLAB/GOAT/Archive/Indices/PDO.xlsx') ;

FieldDescription = 'Pacific Decadal Oscillarion  (Principle component of North (>20) Pacific SST anomalies) source = jisao.washington.edu' ; 
lat = 0 ; 
lon = 0 ; 
lev = 0 ; 
Units = 'None' ; 
VerticalOrdinate = 'Pressure (mb)' ; 

save(fullfile(GOAT_Address,'Dims.mat'),'lat','lon','lev','Units','VerticalOrdinate','FieldDescription') ; 


pdo = zeros(size(raw,1),13) ;
for i = 1:size(raw,1)
   pdo(i,:) = str2num(cell2mat(raw(i))) ; 
end


for i = 1:size(pdo,1)
    year = pdo(i,1) ;
    for j = 1:12
    data = pdo(j+1) ; 
    mkdir(fullfile(GOAT_Address,int2str(year))) ; 
    save(fullfile(GOAT_Address,int2str(year),[int2str(j*10000),'.mat']),'data')
    end
    
end



