% GPCC file downloaded via http://www.esrl.noaa.gov/psd/data/gridded/data.gpcc.html
% monthly data from Jan.1901 to 2013
[fid,fidf] = uigetfile('*,*') ;
D = GOAT_nc2mat([fidf,fid]) ;
%%
lon = D.lon ;
lat = D.lat ;
P = 1000 ;
Units = 'kg/m^2s' ;
VerticalOrdinate = 'Pressure (mb)' ;
FieldDescription = 'Precipitation' ;
GPCCdir = '../Data/GPCC/Monthly/pr/' ;
mkdir(GPCCdir)
save([GPCCdir,'Dims.mat'],'lon','lat','P','Units','VerticalOrdinate','FieldDescription') ; 
%%
q = 0 ; 
for y = 1901:2012
    for m = 1:12
        mkdir([GPCCdir,int2str(y)]) ;
        switch m
            case {1,3,5,7,8,10,12}
                mdays = 31 ;
            case {4,6,9,11}
                mdays = 30 ;
            case 2
                if GOAT_leapyear(y)
                    mdays = 29 ;
                else
                    mdays = 28 ;
                end
        end
        q = q + 1 ; 
        data = D.dim1(:,:,q) ;
        data(data<-9999) = nan ; 
        data =single(data/mdays/24/3600) ; 
        save(fullfile(GPCCdir,int2str(y),[int2str(m*10000),'.mat']),'data') ; 
    end
end

