% GPCC Conversion Code
% First Get Dims and set up Folder
GPCPraw = uigetdir ; 
[pth, name, ext] = fileparts(GPCPraw) ; 
GPCPdir = fullfile(pth,'GPCP','Daily','prate') ; 
mkdir(GPCPdir) ; 
D = GOAT_nc2mat(fullfile(GPCPraw,['gpcp_1dd_v1.1_p1d.',int2str(1996),int2str(10),'.gz.nc'])) ; 
try
lat = D.lat ; 
lon = D.lon ;
catch
lat = D.dim2 ; 
lon = D.var1 ;
end
P   = 1000 ; 
Units = 'mm/day' ; 
FieldDescription = 'Precipitation Rate' ; 
VerticalOrdinate = 'Pressure (mb)' ; 
save(fullfile(GPCPdir,'Dims.mat'),'lat','lon','P','Units','FieldDescription','VerticalOrdinate') ; 

for y = 1996:2010
    try
    mkdir(fullfile(GPCPdir,int2str(y),'')) ; 
    
    for m = 1 : 12
       try
        clear D
        D = GOAT_nc2mat(fullfile(GPCPraw,['gpcp_1dd_v1.1_p1d.',int2str(y*100+m),'.gz.nc'])) ; 
         for d = 1:size(D.dim1,3) ; 
         data = squeeze(D.dim1(:,:,d)) ; 
         data(data < -1000) = 0 ; 
         save(fullfile(GPCPdir,int2str(y),[int2str(m*10000+d*100),'.mat']),'data') ;
         end
       catch
           % Nevermind
       end
    end
    
    catch
    disp(['could not save ',fullfile(GPCPdir,int2str(y),[int2str(m*10000+d*100),'.mat'])])    
    try
    rmdir(fullfile(GPCPdir,int2str(y),'')) ;
    end
    end
end

