 % Install MERRA LINK data
 G = GOAT_Environment('enter_project_path') ; % Initiate GOAT Environment

FieldsToInstall = {'cli','clw','epv','hur','hus','o3','ps','psl','ta','ua','va','wap','zg','zgs'} ; 
Calendar = 'Monthly' ; 
ExportDataSetAddress = '/Volumes/data3/GOAT/Data/MERRA_inst_asm' ; 
year1  = 1979 ; % yyyy
month1 = 1    ; % 1:12
day1   = 1    ; % 1:31 
hour1  = 0    ; % 0:3:21
year2  = 2014 ; 
month2 = 12    ; 
day2   = 31    ; 
hour2  = 0    ; 
G = GOAT_Initialize_Dataset(G,'/Volumes/data3/GOAT/Data_LINK/MERRA_LINK/inst_3d_asm_Cp',Calendar) ; % Go through contents of Data folder and Calendar. Link existing fields, temporal span, etc.

for F = 1:length(FieldsToInstall)
G = GOAT_Initialize_Field(G,FieldsToInstall{F})        ; % get spatial and temporal dimensions of field, display settings, topography, and file addresses. Link if necessary
G.Limits.Default.Day2same   = 0 ; % 1/0 Set Date 2 same as Date 1
G.Limits.Default.Sequential = 1 ; % 1/0 Sequential or Seasonal averaging Flag
G.Limits.Default.ClimatologyContinuous = 0 ; % present seasonal data sequentially in Hovmoller plots
G.Limits.Default.Anom  = 0      ; % display anomalies in Hovmoller plots
G.Limits.S1 = GOAT_getSerial(year1,month1,day1,hour1,G.TimeFieldVirtual,G.Limits.Year0) ; 
if G.Limits.Default.Day2same && G.Limits.Default.Sequential
    G.Limits.S2 = G.Limits.S1 ;
else
G.Limits.S2 = GOAT_getSerial(year2,month2,day2,hour2,G.TimeFieldVirtual,G.Limits.Year0) ; 
end 
G.ProjectionType = 10 ; % 
G.ALP.ExportAddress  = fullfile(ExportDataSetAddress,Calendar,FieldsToInstall{F}) ; % 
G.ALP.Calendar       = Calendar ; % Calendar
G.ALP.OverWriteFlag  = 1 ; % when checked, data will NOT be overwritten
if F == 1
G.ALP.BoerBetaFlag   = 1 ; % create BoerBeta function
else
G.ALP.BoerBetaFlag   = 0 ; % create BoerBeta function    
end
G.ALP.SaveSingle     = 0 ; % save data as single precision
G = GOAT_ALP_Install(G) ; % Install as MAT archive format from OPeNDAP server or nc file 
end