% BoerBeta from gph and land mask
% Get DailyXX/Monthly folder
warning off all
TimeDir = uigetdir ;
gphDir = fullfile(TimeDir,'zg','') ;
load(fullfile(gphDir,'Dims.mat')) ;
LatG = lat ;
LonG = lon ;
BoerDir = fullfile(TimeDir,'BoerBeta','') ;
mkdir(BoerDir) ;
FieldDescription = 'Boer Beta function: 0 for gph < Topographic Mask  |  1 for gph > Topographic Mask'  ;
Units = 'Unitless' ;
VerticalOrdinate = 'Pressure (mb)' ;
save(fullfile(BoerDir,'Dims.mat'),'lon','lat','P','Units','FieldDescription','VerticalOrdinate') ;

load('Topography.mat') ; 
topolat = [-89.5:89.5];     % CREATE LAT ARRAY FOR TOPO MATRIX
topolon = [0.5:359.5];      % CREATE LON ARRAY FOR TOPO MATRIX

topo = topo' ;
[X1, X2] = ndgrid(topolon,topolat);
F = griddedInterpolant(X1,X2,topo);
latf = lat*-sign(lat(1)) ; 
[lonG, latG] = ndgrid(lon,latf);
topoG = F(lonG,latG);
topo90N = (topo(:,end)*1.5 - topo(:,end-1)*.5) ;
topo90S = (topo(:,1  )*1.5 - topo(:,2)*.5) ;

topoGN = interp1(topolon',topo90N,lon) ;
topoGS = interp1(topolon',topo90S,lon) ;

topoG(:,1) = topoGS ;
topoG(:,end) = topoGN ;

topo0 = (topo(1,:) + topo(end,:))/2 ;
topoG0 = interp1(topolat,topo0,latf) ;
topoG(1,:) = topoG0 ;
topoG(1,  1) = (topo90S(1) + topo90S(end))/2 ;
topoG(1,end) = (topo90N(1) + topo90N(end))/2 ;

topoG = flipdim(topoG,2) ;

topoRep = repmat(reshape(topoG,size(topoG,1),size(topoG,2),1),[1 1 length(P)] ) ;
%
yearsdir = dir(gphDir) ;
Ny = 0 ;
years = [] ;
for j = 1:length(yearsdir)
    if yearsdir(j,1).isdir && ...
            ~strncmp(yearsdir(j,1).name,'.',1)
        Ny = Ny + 1 ;
        years(Ny) = round(str2double(yearsdir(j,1).name)) ;
    end
end
%
tic ;
q =0 ;
for y = years(1):years(end)
    disp(['BoerBeta  ',int2str(y),' . . .']) ;
    for m = 1:12
        for d = 1:32
            for h = 1:8
                try
                    load(fullfile(gphDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat'])) ;
                    data0 = data ;
                    bata = data0*0 ;
                    bata(data0>=topoRep) = 1 ;
                    try
                        save(fullfile(BoerDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat']),'bata') ;
                    catch
                        mkdir(fullfile(BoerDir,int2str(y),'')) ;
                        save(fullfile(BoerDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat']),'bata') ;
                    end
                    q = q + 1 ;
                catch
                    % No Such File
                end
            end
        end
    end
end
te = toc ;
H = floor(te/3600) ;
M = (te - H*3600)/60 ;
if q
    disp(['BoerBeta of ',int2str(q),' files completed in ',int2str(H),' hours and ',int2str(M),' minutes.'])
else
    disp('No file was Generated. ')
end