% GOAT_ALP_DecompressAttributes  Decompress Attributes cell array 
% Copyright (C) Ori Adam, Apr.2014.
% syntax:
% >> DecompressedAttributes = GOAT_ALP_DecompressAttributes(CompressedAttributes)
%
% see also GOAT_ALP_CompressAttributes

function DecompressedAttributes = GOAT_ALP_DecompressAttributes(CompressedAttributes)
%%
if isempty(CompressedAttributes{end,5})
   % Attributes is not Compressed
    DecompressedAttributes = CompressedAttributes ;
    return
end
DecompressedAttributes = cell(CompressedAttributes{end,5}+1,size(CompressedAttributes,2)) ;
DecompressedAttributes(end,:) = CompressedAttributes(end,:) ;
DecompressedAttributes(end,5) = {[]} ;


for j = 1:size(CompressedAttributes,2)
    AC = CompressedAttributes{1,j} ; 
    qc = 1 ; 
    for c = 1:size(AC,1)
      if isempty(AC{c,2}) % same as multiplier = 1
          DecompressedAttributes(qc,j) = AC(c,1) ; 
          qc = qc +1 ; 
      elseif isnumeric(AC{c,2})
           multiplier = AC{c,2} ;
           DecompressedAttributes(qc:qc+multiplier-1,j) = repmat(AC(c,1),[multiplier 1]) ;
           qc = qc + multiplier ; 
      elseif strcmp(AC(c,2),'eval') % an eval string
           eval(AC{c,1}) ;
           s = size(Col,1) ; 
           DecompressedAttributes(qc:qc+s-1,j) = Col ;
           qc = qc + s ; 
      end
    end
end
          


