% GOAT_Display_message: report using disp or dispstat if in GOAT environment mode or report in GUI message area if in GUI mode
% syntax:
% >> GOAT_Display_message(G,Message,Option)
% >> GOAT_Display_message(G,Message,'init')   --> initialize static message
% >> GOAT_Display_message(G,Message,'stat')   --> static message
% >> GOAT_Display_message(G,Message,)  = disp(message)
% see also, GOAT_dispstat

function GOAT_Display_message(G,Message,Option)
try
    if G.Display.message_Flag == 1
        return
    end
end
    
if nargin == 2
    Option = 'None' ;
end
switch Option
    case 'keepprev'
        if G.EnvironmentFlag
            GOAT_dispstat(Message,'keepprev') ;
        else
            if ~isempty(Message)
                try
                    set(G.h_message,'string',Message) ; drawnow ;
                catch
                    % Nevermind
                end
            end
        end
    case 'keepthis'
        if G.EnvironmentFlag
            GOAT_dispstat(Message,'keepthis') ;
        else
            if ~isempty(Message)
                try
                    set(G.h_message,'string',Message) ; drawnow ;
                catch
                    % Nevermind
                end
            end
        end
    case 'init'
        if G.EnvironmentFlag
            GOAT_dispstat('','init') ;
        else
            if ~isempty(Message)
                try
                    set(G.h_message,'string',Message) ; drawnow ;
                catch
                    % Nevermind
                end
            end
        end
    case 'stat'
        if G.EnvironmentFlag
            GOAT_dispstat(Message) ;
        else
            try
                set(G.h_message,'string',Message) ; drawnow ;
            catch
                % Nevermind
            end
        end
    otherwise
        if G.EnvironmentFlag
            disp(Message) ;
        else
            try
                set(G.h_message,'string',Message) ; drawnow ;
            catch
                % Nevermind
            end
        end
end
