% GOAT_Hold_Data
% Replave current data and plot settings with 'held' data stored in G.Hold
% syntax:
% >> G = GOAT_Hold_Back(G)
%
% see also, GOAT_Hold_Data

function G = GOAT_Hold_Back(G)
try
    G.message = Hold.infoMessage  ;
end
G.DataFieldUnits = G.Hold.Units                            ;
G.FieldDescription = G.Hold.Description                    ;
try
G.Display.colorbarLimits = G.Hold.colorbarLimits                     ;
G.Display.colorbarHandle = G.Hold.colorbarHandle                     ;
end
Namelist = {'Data','X','x','y','Y','xlabel','ylabel','datalabel','Dates','FilteredDates','Filter','Limits.Default.sameP','Limits.Default.VerMeanInt','lon', ...
    'lat','P','lonlabel','latlabel','Plabel','Limits.Default.Lat1','Limits.Default.Lat2','Limits.Default.Lon1','Limits.Default.Lon2','Limits.Default.P1','Limits.Default.P2', ... 
    'Settings.ColorMapIdx','Settings.CoastLineWidthIdx','Settings.XgridFlag','Settings.YgridFlag','Settings.SymZLimitsFlag','Settings.FixZLimitsFlag','Settings.LogLevelsFlag','Settings.ContourLevelStep', ... 
    'Settings.ReverseColorMap','Settings.LineWidthIdx','Settings.LineWidth','Settings.CoastLineWidth','topo.TypeFlag','DataSeries','DataClim','DataSeriesAnom','Settings.SinLatFlag'} ; 

for j = 1:length(Namelist)
    try
    G.(Namelist{j}) = G.Hold.(Namelist{j}) ; 
    end
end
