% GOAT_JulianDate output Date from Julian day (1:366) for a given year
% Copyright (C) Ori Adam Nov.2012. 
%
% syntax:
% >> [month,day] = GOAT_JulianDate(year,JulianDay)
%
% see also, GOAT_JulianDay, monthday2dayIdx, yearday2monthday

function [m,d] = GOAT_JulianDate(y,D)
% Output day in Julian Days
if GOAT_leapyear(y)
    MEnd = [0 31 60 91 121 152 182 213 244 274 305 335 366] ;
else
    MEnd = [0 31 59 90 120 151 181 212 243 273 304 334 365] ;
end

m = find(D<=MEnd,1,'first')-1 ; 
d = D - MEnd(m) ; 

return