% GOAT_JulianDay output Julian day (1:366) from year,month,day
% Copyright (C) Ori Adam Nov.2012.
% syntax: Jd = GOAT_JulianDay(y,m,d,Calendar)
% >> 
% see also, monthday2dayIdx, yearday2monthday

function Jd = GOAT_JulianDay(y,m,d,TimeResolution)
% Output day in Julian Days
if nargin < 4
    if GOAT_leapyear(y)
        MEnd = [0 31 60 91 121 152 182 213 244 274 305 335] ;
    else
        MEnd = [0 31 59 90 120 151 181 212 243 273 304 334] ;
    end
    Jd = MEnd(m) + d ; return
else
    if strncmpi(TimeResolution,'Month',5)
       Jd = 0 ; return
    elseif strncmpi(TimeResolution,'Julian',6)
       Jd = d ; return
    elseif strncmpi(TimeResolution,'Daily360',8)
       MEnd = [0 30 60 90 120 150 180 210 240 270 300 330] ;
       Jd = MEnd(m) + d ; return
    else
      if GOAT_leapyear(y,TimeResolution)
        MEnd = [0 31 60 91 121 152 182 213 244 274 305 335] ;
      else
        MEnd = [0 31 59 90 120 151 181 212 243 273 304 334] ;
      end
      Jd = MEnd(m) + d ; return
    end
end
