% LOAD Make sure Existing Limits are suited to new field dimensions and adjust if necessary
% Copyright (C) Ori Adam March.2012. Compatible with version 2013i or later
%
% see also GOAT_Defaults, GOAT_GetDims, GOAT_GetFieldSpan, GOAT_NewFieldLimits, GOAT_Filters, GOAT_Initialize_Dataset

function G = GOAT_NewFieldLimits(G)
if strcmpi(G.TimeField,'List')
    G.Limits.Default.time1      = 1                  ; % Default linear time
    G.Limits.Default.time2      = length(G.Addresses.Default) ; % Default Linear Time Index 2
else
    try
        if G.Limits.S1<G.Limits.Smin || G.Limits.S2>G.Limits.Smax ...
                || ~isequal([G.Limits.Smin, G.Limits.Smax,G.Limits.Year0],[G.Limits.SminOld, G.Limits.SmaxOld,G.Limits.Year0Old])
            G.Limits.Default.year1      = G.Limits.FirstYear ; % Default year1 for new field
            G.Limits.Default.year2      = G.Limits.LastYear  ; % Default year2 for new field
            G.Limits.Default.H1         = G.Limits.FirstHour ; % Default hour1 for new field
            G.Limits.Default.H2         = G.Limits.LastHour  ; % Default hour2 for new field
            G.Limits.Default.day1       = G.Limits.FirstDay  ; % Default day1 for new field
            G.Limits.Default.day2       = G.Limits.LastDay   ; % Default day2 for new field
            G.Limits.Default.month1     = G.Limits.FirstMonth ; % Month 1
            G.Limits.Default.month2     = G.Limits.LastMonth ; % Month 2
            G.Limits.Default.time1      = 1                  ; % Default linear time
            G.Limits.Default.time2      = length(G.Addresses.Default) ; % Default Linear Time Index 2
            %G.Limits.Default.Day2same   = 1 ; % Set Date 2 same as Date 1 Flag
        end
    catch
        G.Limits.Default.time1      = 1                  ; % Default linear time
        G.Limits.Default.time2      = length(G.Addresses.Default) ; % Default Linear Time Index 2
        G.Limits.Default.year1      = G.Limits.FirstYear ; % Default year1 for new field
        G.Limits.Default.year2      = G.Limits.LastYear  ; % Default year2 for new field
        G.Limits.Default.day1       = G.Limits.FirstDay  ; % Default day1 for new field
        G.Limits.Default.day2       = G.Limits.LastDay   ; % Default day2 for new field
        G.Limits.Default.month1     = G.Limits.FirstMonth ; % Month 1
        G.Limits.Default.month2     = G.Limits.LastMonth  ; % Month 2
        G.Limits.Default.H1         = G.Limits.FirstHour  ; % hour 1
        G.Limits.Default.H2         = G.Limits.LastHour   ; % hour 2
        %G.Limits.Default.Day2same   = 1 ; % Set Date 2 same as Date 1 Flag
    end
end
try
    if max([G.Limits.Default.Lev1,G.Limits.Default.Lev2]) > length(G.lev) ...
            || ~isequal(G.POld,G.lev)
        G.Limits.Default.Lev1       = 1             ; % Default Pressure level 1
        G.Limits.Default.Lev2       = length(G.lev) ; % Default Pressure level 2
    end
    if max([G.Limits.Default.Lat1,G.Limits.Default.Lat2]) > length(G.lat) ...
            || ~isequal(G.latOld,G.lat)
        G.Limits.Default.Lat1       = 1             ; % Default Latitude 1
        G.Limits.Default.Lat2       = length(G.lat) ; % Default Latitude 2
    end
    if max([G.Limits.Default.Lon1,G.Limits.Default.Lon2]) > length(G.lon) ...
            || ~isequal(G.lonOld,G.lon)
        G.Limits.Default.Lon1       = 1             ; % Default Longitude 2
        G.Limits.Default.Lon2       = length(G.lon) ; % Default Longitude 1
    end
catch
    G.Limits.Default.Lev1       = 1             ; % Default Pressure level 1
    G.Limits.Default.Lev2       = length(G.lev) ; % Default Pressure level 2
    G.Limits.Default.Lat1       = 1             ; % Default Latitude 1
    G.Limits.Default.Lat2       = length(G.lat) ; % Default Latitude 2
    G.Limits.Default.Lon1       = 1             ; % Default Longitude 2
    G.Limits.Default.Lon2       = length(G.lon) ; % Default Longitude 1
    %G.Limits.Default.sameP      = 1 ; % Same Pressure Level Flag
end