% GOAT_custom_field_settings   curtomized field settings
% Copyright (C) Ori Adam Sep.2013. compatible with version 2013i or later
%
% see also GOAT_FieldSettings

function G = GOAT_custom_field_settings(G)

% Custom1
G.Settings.Custom1.NanMeanFlag       = 1                                    ; % use mean(x) function when 0 and nanmean(x) when 1 ;
G.Settings.Custom1.ContourIdx        = G.Settings.Default.ContourIdx        ; % Contour Type Idx
G.Settings.Custom1.WaitbarCutoff     = G.Settings.Default.WaitbarCutoff     ; % Number of data loadings above which the waitbar appears
G.Settings.Custom1.ColorMapIdx      = find(strcmp(G.Settings.ColorMap,'BlueWhiteRed'))  ; % BlueWhiteRed
G.Settings.Custom1.LineWidthIdx      = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom1.LineWidth         = (G.Settings.LineWidthIdx-2)/2 ;
G.Settings.Custom1.CoastLineWidthIdx = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom1.CoastLineWidth    = G.Settings.CoastLineWidthIdx/2 - .5 ;    
G.Settings.Custom1.XgridFlag         = G.Settings.Default.XgridFlag         ; % A flag for displaying the X Grid Lines
G.Settings.Custom1.YgridFlag         = G.Settings.Default.YgridFlag         ; % A flag for displaying the Y Grid Lines
G.Settings.Custom1.SymZLimitsFlag    = 1                                    ; % A flag for setting limits symmetric with respect to zero (goes well with blue white red colormaps)
G.Settings.Custom1.FixZLimitsFlag    = G.Settings.Default.FixZLimitsFlag    ; % A flag for fixing limits (useful in auto time steps)
G.Settings.Custom1.LogLevelsFlag     = G.Settings.Default.LogLevelsFlag     ; % log(P) in lat-P,Lon-P projections
G.Settings.Custom1.topoTypeFlag      = 2                                    ; % 1) None 2) Atmo 3) Ocean 4) All 
G.Settings.Custom1.ContourLevelStep  = 0                                    ; % Manual Contour Step Level. 0 = Auto.
G.Settings.Custom1.ReverseColorMap   = 0                                    ; % Reverse Colormap 
% Custom2
G.Settings.Custom2.NanMeanFlag       = 0                                    ; % use mean(x) function when 0 and nanmean(x) when 1 ;
G.Settings.Custom2.ContourIdx        = G.Settings.Default.ContourIdx        ; % Contour Type Idx
G.Settings.Custom2.WaitbarCutoff     = G.Settings.Default.WaitbarCutoff     ; % Number of data loadings above which the waitbar appears
%G.Settings.Customx2.ColorMapIdx       = find(strcmp(G.Settings.ColorMap,'BlueWhiteRed'))  ; % BlueWhiteRed
G.Settings.Custom2.ColorMapIdx       = find(strcmp(G.Settings.ColorMap,'RdBu11'))  ; % RedBlue
G.Settings.Custom2.LineWidthIdx      = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom2.LineWidth         = (G.Settings.LineWidthIdx-2)/2 ;
G.Settings.Custom2.CoastLineWidthIdx = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom2.CoastLineWidth    = G.Settings.CoastLineWidthIdx/2 - .5 ;    
G.Settings.Custom2.XgridFlag         = G.Settings.Default.XgridFlag         ; % A flag for displaying the X Grid Lines
G.Settings.Custom2.YgridFlag         = G.Settings.Default.YgridFlag         ; % A flag for displaying the Y Grid Lines
G.Settings.Custom2.SymZLimitsFlag    = 1                                    ; % A flag for setting limits symmetric with respect to zero (goes well with blue white red colormaps)
G.Settings.Custom2.FixZLimitsFlag    = G.Settings.Default.FixZLimitsFlag    ; % A flag for fixing limits (useful in auto time steps)
G.Settings.Custom2.LogLevelsFlag     = G.Settings.Default.LogLevelsFlag     ; % log(P) in lat-P,Lon-P projections
G.Settings.Custom2.topoTypeFlag      = 2                                    ; % 1) None 2) Atmo 3) Ocean 4) All 
G.Settings.Custom2.ContourLevelStep  = 0                                    ; % Manual Contour Step Level. 0 = Auto.
G.Settings.Custom2.ReverseColorMap   = 1                                    ; % Reverse Colormap 
% Custom3
G.Settings.Custom3.NanMeanFlag       = 0                                    ; % use mean(x) function when 0 and nanmean(x) when 1 ;
G.Settings.Custom3.ContourIdx        = G.Settings.Default.ContourIdx        ; % Contour Type Idx
G.Settings.Custom3.WaitbarCutoff     = G.Settings.Default.WaitbarCutoff     ; % Number of data loadings above which the waitbar appears
G.Settings.Custom3.ColorMapIdx       = find(strcmp(G.Settings.ColorMap,'RdYlBu_11b'))  ; % RedYellowBlue
G.Settings.Custom3.LineWidthIdx      = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom3.LineWidth         = (G.Settings.LineWidthIdx-2)/2 ;
G.Settings.Custom3.CoastLineWidthIdx = 1                                    ; % Default LineWidth Index in Plots
G.Settings.Custom3.CoastLineWidth    = G.Settings.CoastLineWidthIdx/2 - .5 ;    
G.Settings.Custom3.XgridFlag         = G.Settings.Default.XgridFlag         ; % A flag for displaying the X Grid Lines
G.Settings.Custom3.YgridFlag         = G.Settings.Default.YgridFlag         ; % A flag for displaying the Y Grid Lines
G.Settings.Custom3.SymZLimitsFlag    = 0                                    ; % A flag for setting limits symmetric with respect to zero (goes well with blue white red colormaps)
G.Settings.Custom3.FixZLimitsFlag    = G.Settings.Default.FixZLimitsFlag    ; % A flag for fixing limits (useful in auto time steps)
G.Settings.Custom3.LogLevelsFlag     = G.Settings.Default.LogLevelsFlag     ; % log(P) in lat-P,Lon-P projections
G.Settings.Custom3.topoTypeFlag      = 2                                    ; % 1) None 2) Atmo 3) Ocean 4) All 
G.Settings.Custom3.ContourLevelStep  = 0                                    ; % Manual Contour Step Level. 0 = Auto.
G.Settings.Custom3.ReverseColorMap   = 1                                    ; % Reverse Colormap 