% GOAT_setProjectionStr    Set Projection String in GOAT GUI
% Copyright (c) Ori Adam, March.24.2014
%
function G = GOAT_setProjectionStr(G)
switch G.VerticalOrdinate
    case 'Pressure (mb)'
        %G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Pressure | Lon-Pressure | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-P ' ;
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Pressure | Lon-Pressure | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-P | NH Polar Stereographic | SH Polar Stereographic' ;
    case 'Depth (m)'
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Depth | Lon-Depth | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-Depth | NH Polar Stereographic | SH Polar Stereographic' ;       
    case 'Sigma'
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Sigma | Lon-Sigma | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-Sigma | NH Polar Stereographic | SH Polar Stereographic' ;        
    case 'Height (m)'
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Height | Lon-Height | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-Height | NH Polar Stereographic | SH Polar Stereographic' ;    
    case 'Potential Temperature (K)'
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Pot.Temp | Lon-Pot.Temp | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-Pot.Temp | NH Polar Stereographic | SH Polar Stereographic' ;       
    otherwise
        G.GUI.ProjectionStr = 'Lat-Lon LandCover | Lat-Lon | Lat-Level | Lon-Level | Hovmoller-Lon | Hovmoller-Lat | Hovmoller-Level | NH Polar Stereographic | SH Polar Stereographic' ;
end
if isfield(G.Addresses,'Attributes')
    if ~isempty(G.Addresses.Attributes)
        G.GUI.ProjectionStr = [G.GUI.ProjectionStr,' | Install linked data as *.mat'] ;
    end
end
return