% GOAT_MonthlyIndex2Daily Convert Monthly Index To Daily
% Written by Ori Adam 2012
%
% see also GOAT_DailyIndex2Monthly

[Fid, Fidf] = uigetfile ; 

load([Fidf,Fid]) ; % Load Index

[Path, Name, Ext] = fileparts([Fidf,Fid]) ; 

year1 = 1800  ; year2 = 2200 ; 

DailyIndex = zeros(100000,1) ;
q = 0 ; 
M = 800 ; 
for y = year1: year2
    for m = 1:12
        M = M + 1 ; 
        switch m
            case {1,3,5,7,8,10,12}
                for d = 1:31
                    q = q + 1 ;
                    DailyIndex(q) = Index(M) ;
                end
            case {4,6,9,11}
                for d = 1:30
                    q = q + 1 ;
                    DailyIndex(q) = Index(M) ;
                end
            case 2
                if GOAT_leapyear(y)
                    for d = 1:29
                        q = q + 1 ;
                        DailyIndex(q) = Index(M) ;
                    end
                else
                    for d = 1:28
                        q = q + 1 ;
                        DailyIndex(q) = Index(M) ;
                    end
                end
        end
    end
end

Index = DailyIndex(1:q) ;

save(fullfile(Path,[Name,'_daily.mat']),'Index') ; 
