% SOM produce SOM table
% writen by Ori Adam 2012.
%
% 

function SOMtable(FigHandle,values,colors,ColumnHeaders,RowHeaders)

FigBackgroudColor = [ 1  1  1]       ; % White Figure Background color
HeaderColor       = [.1 .1 .1]       ; % Header Color
ValueColor        = [ 0  0  0]       ; % Values Color
Nc = size(values,2) ; 
Nr = size(values,1) ;

H = 1/(Nr + 1) ; 
W = 1/(Nc + 1) ;
eH = H*.02 ;
eW = W*.02 ; 
uicontrol('parent',FigHandle,'Style','text','Units','normalized','pos',[eW,1-H+eH,W-2*eW,H-2*eH], 'string','','BackgroundColor',FigBackgroudColor,'ForegroundColor',HeaderColor,'FontSize',16,'Fontweight','bold') ;
for i = 1: Nc 
   uicontrol('parent',FigHandle,'Style','text','Units','normalized','pos',[i*W+eW,1-H+eH,W-2*eW,H-2*eH], 'string',ColumnHeaders(i),'BackgroundColor',FigBackgroudColor,'ForegroundColor',HeaderColor,'FontSize',16,'Fontweight','bold') ;
end
for i = 1: Nr 
   uicontrol('parent',FigHandle,'Style','text','Units','normalized','pos',[0+eW,1-(i+1)*H + eH,W-2*eW,H-2*eH], 'string',RowHeaders(i),'BackgroundColor',FigBackgroudColor,'ForegroundColor',HeaderColor,'FontSize',16,'Fontweight','bold') ;
end

for c = 1:Nc
    for r = 1:Nr
        vstring = num2str(cell2mat(values(r,c)),3) ; 
        uicontrol('parent',FigHandle,'Style','text','Units','normalized','pos',[c*W+eW,1-(r+1)*H+eH,W-2*eW,H-2*eH], 'string',vstring,'BackgroundColor',cell2mat(colors(r,c)),'ForegroundColor',ValueColor,'FontSize',14) ;
    end
end

