% FILTER Zonal Wave Range Filter
% ZonalWaveNumberIdx specifies the indices of the low and high pass zonal wave limits
%
% see also GOAT_Filters

function Data = ZonalWaveFilter(Data,ZonalWaveNumberIdx) 
Datafft    = fft(Data,[],1)      ;  % data after fft
Datatoifft = zeros(size(Datafft));  % data for ifft
Datatoifft(ZonalWaveNumberIdx + 1,:,:) = Datafft(ZonalWaveNumberIdx + 1, :,:);

if ZonalWaveNumberIdx(1) == 0 && length(ZonalWaveNumberIdx) == 1
  Data = real(ifft(Datatoifft,[],1)) ;
elseif ZonalWaveNumberIdx(1) == 0  
    ZonalWaveNumberIdx = ZonalWaveNumberIdx(2:end) ;
    Datatoifft(end - ZonalWaveNumberIdx +1,:,:) = Datafft(end - ZonalWaveNumberIdx + 1, :,:);
    Data = real(ifft(Datatoifft,[],1)) ;
else
    Datatoifft(end - ZonalWaveNumberIdx +1,:,:) = Datafft(end - ZonalWaveNumberIdx + 1, :,:);
    Data = real(ifft(Datatoifft,[],1)) ;
end
