% determine hovmoller date display format
% Copyright (C) Ori Adam Aug.2013. Compatible with version 2013i or later
% available formats:
% 'linear'
% 'mmm'
% 'mmm.dd'
% 'yy.mmm'
% 'yy.mmm.dd'
% 'yy.mm.dd'
% 'yyyy.mmm.dd'
% 'yyyy.mm.dd'
% 'yyyy.ddd' - Julian
% see also datastringvec2data, datastring2date, GOAT_plotUpdate

function dateformat = hovmollerformt(G)
if strcmpi(G.TimeFieldVirtual,'linear')
    dateformat = 'linear' ;
else
    if strncmpi(G.TimeFieldVirtual,'Julian',6)
        dateformat = 'Julian.yyyy.ddd' ;
    else % Gregorian
        if G.Limits.Default.Sequential
            dateformat = 'yyyy.mmm.dd' ;
        else
            if G.Limits.Default.ClimatologyContinuous
                dateformat = 'yyyy.mmm.dd' ;
            else
                dateformat = 'mmm.dd' ;
            end
        end
    end
end

