% GOAT_Examples_CreateIndex: 
% this example shows how to create a GOAT index which excludes the years 2003 and 2008 for the variable 'ua'
G = GOAT_Environment('../WORK/Project_WorkFolder') ; 
G = GOAT_Initialize_Dataset(G,'GOAT/Data/ERA-Interim','Monthly') ; % Go through contents of Data folder. identify existing fields, temporal span, etc.
G = GOAT_Initialize_Field(G,'ua')        ; % get spatial and temporal dimensions and display settings                                                      
%% Create Index using a loop
Index = ones(length(G.Addresses.Default),1) ; % Default Index (all ones)
for i = 1:length(Index) ;
    % The GOAT function GOAT_serial2date takes as input G.Addresses.Default and an index and returns
    % [year,month,day,hour] corresponding to G.Addresses.Default(i)
    [year,month,day,hour] = GOAT_serial2date(G.Addresses.Default,i) ;
    if any(year == [2003, 2008])
        Index(i) = 0 ; 
    end
end
save(fullfile('GOAT','Data','ERA-Interim','Indices','Exclude_2003_2008.mat'),'Index') ; 