% GOAT_MyDefaults Personalized GOAT Settings
% Copyright (C) Ori Adam Aug.2013. Compatible with version 2013i or later.
%
% see also GOAT, GOAT_AutoDownload, GOAT_Environment 

function G = GOAT_MyDefaults(G)
G.pos        = [G.scrsz(4)      G.scrsz(4)      G.scrsz(3)      G.scrsz(4)].*[.1 .1 .7 .7]  ; % General use position vector
G.Saving.PapersizeWide   = [17 13]      ; % Paper size for pdf export
G.Saving.PapersizeTall   = [13 11]      ; % Paper size for pdf export
G.Saving.PapersizeSquare = [15 15]      ; % Paper size for pdf export
G.Saving.PapersizeGUI    = [28 18]      ; % Paper size for pdf export of GUI image
G.Saving.dpdfResolution  = '-r80'       ; % resolution of printed pdf during export ('-dpdf' renderer)
G.Display.TextSize_XL    = 18           ; % Standardized Text Font Size 'X-Large'
G.Display.TextSize_L     = 16           ; % Standardized Text Font Size 'Large'
G.Display.TextSize_M     = 14           ; % Standardized Text Font Size 'Medium'
G.Display.TextSize_S     = 12           ; % Standardized Text Font Size 'Small' 
G.GUI.Fonts.gcaFont      = 'sans-serif' ; % Matlab Default  = Helvetica
G.GUI.Fonts.uiButtonFont = 'Bangla MN'  ; % Matlab Default  = Helvetica
G.GUI.Fonts.uiHeaderFont = 'Bangla MN'  ; % Matlab Default  = Helvetica
G.GUI.Fonts.MessageFont  = 'Cambria'    ; % Matlab Default  = Helvetica
G.topo.ShadeColor  = [.5 .5 .5]         ; % Land Surfaces Shading Color
G.topo.alpha       = .4                 ; % visibility of land areas
G.topo.Lakealpha   = .4                 ; % visibility of lake areas
% dependent on window pixel resolution 
G.GUI.pos.Main      = [G.scrsz(3)        G.scrsz(4)      G.scrsz(3)      G.scrsz(4)].*[.025 .05 .95 .9]  ; % Main GOAT GUI Window dimensions
G.GUI.pos.Export    = [G.scrsz(3)*1/5    G.scrsz(4)/10   G.scrsz(3)*3/5  G.scrsz(3)*1/5] ; % Export GUI Window dimensions
G.GUI.pos.Limits    = [G.scrsz(3)*1/5    G.scrsz(4)/10   G.scrsz(3)*3/5  G.scrsz(4)*4/5] ; % Limits GUI Window dimensions
G.GUI.pos.Filter    = [G.scrsz(3)*1/5    G.scrsz(4)/10   G.scrsz(3)*2/5  G.scrsz(4)*4/5] ; % Filter GUI Window dimensions
G.GUI.pos.Settings  = [G.scrsz(3)*1.5/5  G.scrsz(4)/10   G.scrsz(3)*2/5  G.scrsz(4)*3/5] ; % Settings GUI Window dimensions

G.DataFoldersAddress  = {fullfile('..','Data',''),fullfile('..','Data_LINK','')} ; % NOTE: more than one directory can be specified   
%G.DataFoldersAddress  = {fullfile('/Volumes','data1','Ori','GOAT','Data','')} ; % NOTE: using fullfile allows making address strings that are compatible with all operating systems  
%G.ModelFoldersAddress  = {fullfile('/Volumes','data1','GOAT','Experiment_1'),fullfile('/Volumes','data2','Ori','Dataset_Name')} ; % NOTE: using fullfile makes address strings compatible in all operating systems  
G.Settings.KeyPressFlag = 1 ; % 1/0 Enable Key Press Functions
J = 1 ; 
G.Settings.webLinks(J,1)  = {'https://climatedataguide.ucar.edu/climate-data'}                       ; G.Settings.webLinksTitle(J,1) = {'NCAR-UCAR Climate Data Guide'}; J = J + 1 ;  
G.Settings.webLinks(J,1)  = {'http://www.ecmwf.int/publications/manuals/d/gribapi/param'}            ; G.Settings.webLinksTitle(J,1) = {'ECMWF Param Table'}           ; J = J + 1 ;  
G.Settings.webLinks(J,1)  = {'http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis.html'}  ; G.Settings.webLinksTitle(J,1) = {'NCEP-NCAR Reanalysis I info'} ; J = J + 1 ;  
G.Settings.webLinks(J,1)  = {'http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html'} ; G.Settings.webLinksTitle(J,1) = {'NCEP DOE Reanalysis II info'} ; J = J + 1 ; 
G.Settings.webLinks(J,1)  = {'http://www.esrl.noaa.gov/psd/data/gridded/data.godas.html'}            ; G.Settings.webLinksTitle(J,1) = {'GODAS Info'}                  ; J = J + 1 ; 
G.Settings.webLinks(J,1)  = {'https://www.ncdc.noaa.gov/ersst/'}                                     ; G.Settings.webLinksTitle(J,1) = {'ERSST v3b Info'}              ; J = J + 1 ; 
G.Settings.webLinks(J,1)  = {'http://trmm.gsfc.nasa.gov'}                                            ; G.Settings.webLinksTitle(J,1) = {'TRMM V7 Info'}                ; J = J + 1 ;
G.Settings.webLinks(J,1)  = {'http://gmao.gsfc.nasa.gov/merra/'}                                     ; G.Settings.webLinksTitle(J,1) = {'MERRA Info'}                  ; J = J + 1 ;
G.Settings.webLinks(J,1)  = {'http://www.esrl.noaa.gov/psd/data/20thC_Rean/'}                        ; G.Settings.webLinksTitle(J,1) = {'20C Reanalysis Info'}         ; J = J + 1 ;
G.Settings.webLinks(J,1)  = {'www.oriadam.info'}                                                     ; G.Settings.webLinksTitle(J,1) = {'Ori Adam''s Homepage'}        ; J = J + 1 ;
G.Settings.webLinks(J,1)  = {'www.goat-geo.org'}                                                     ; G.Settings.webLinksTitle(J,1) = {'GOAT Homepage'}               ; J = J + 1 ;
G.Settings.webLinks(J,1)  = {'https://www.facebook.com/amrinan.metalband'}                           ; G.Settings.webLinksTitle(J,1) = {'Amrinan'}                     ; J = J + 1 ;



